﻿#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <engine>
#include <xs>
#include <hamsandwich>
#include <WPMGPrintChatColor>
#include <fakemeta>

/*
	@id - player id
	@data - array with player stats
		data[0] - player experience
		data[1] - player level
		data[2] - player bonuses
		data[3] - player next level experience
	
	@return - 
		0 on fail
		1 on success
	
	native aes_get_player_stats(id,data[4])
*/
native aes_get_player_stats(id,data[4]);
/*
	@id - player id
	@bonus - bonus points to add
	
	@return -
		0 - on fail
		1 - on success
		2 - on overset
		
	native aes_add_player_bonus(id,bonus)
*/
native aes_add_player_bonus(id,bonus);

enum _:STRUSERDATA {
	UD_STEAMID[64],
	UD_TIME
}
enum _:PLAYERDATA {
	PL_ID,
	PL_STEAMID[33],
	PL_NAME[64],
	PL_IP[33],
	PL_TIME
}
new Array:gArrUser;
new Trie:gTrieUser;
new gArrUserNum;

new plData[33][PLAYERDATA];
new Array:gArrayPlayer;
new Trie:gTriePlPointer;
new gArrPlayerNum = 0;
new g_LoadData[256];

new bool:gPlayerInDB[33]; 

const MENU_LENGTH = 512;

new Trie:gArrExists;
new gWriteLine = 0; 

new cvar_time_test_vip;
new cvar_access_flag;

public plugin_precache() {
	cvar_time_test_vip = register_cvar("time_test_vips" , "1440");	//Через сколько минут удалять пользователя. 0 не удалять.
	cvar_access_flag = register_cvar("cvar_access_flag_test" , "t");	//Флаги доступа которые выдаются.

	
	gArrayPlayer = ArrayCreate(PLAYERDATA);
	gTriePlPointer = TrieCreate();
	ReadSave();
	
	gArrExists = TrieCreate();
	// gArrUser
	gArrUser = ArrayCreate(STRUSERDATA);
	gTrieUser = TrieCreate();
	ReadUsers();
}


public plugin_init() {
	register_plugin("Admin Test", "1.0", "[KPbIMSKIY]vk.com/id209348013")
	
	register_clcmd("say /viptest","menu");
	register_clcmd("say_team /viptest","menu");
	
	register_menu("MenuId", 1023, "MenuFunc");
}

public menu(id) {
	static menu[512], len;
	len = 0;
	
	len += formatex(menu[len], charsmax(menu) - len, "\r[\yХалява\r]\wХотите получить тестовый период\r?^n");
	len += formatex(menu[len], charsmax(menu) - len, "\wБудут добавлены флаги \y^"t^"\w сроком на \y1 день^n");
	len += formatex(menu[len], charsmax(menu) - len, "\wТестовый период даётся только \r1 раз!^n^n");
	
	len += formatex(menu[len], charsmax(menu) - len, "\wУ вас будет списано \y5\w очков /anew!^n^n");
	
	len += formatex(menu[len], charsmax(menu) - len, "\r1. \wВзять тестовый период^n");
	

	len += formatex(menu[len], charsmax(menu) - len, "^n\r0. \wВыход" );
	
	new keys = MENU_KEY_0|MENU_KEY_1
	show_menu(id, keys, menu, -1, "MenuId");
	return PLUGIN_HANDLED;
}
public MenuFunc(id,key) {
	
	if(key == 9)
		return PLUGIN_HANDLED;

	
	/*
		@id - player id
		@data - array with player stats
			data[0] - player experience
			data[1] - player level
			data[2] - player bonuses
			data[3] - player next level experience
		
		@return - 
			0 on fail
			1 on success
		
		native aes_get_player_stats(id,data[4])
	*/
	new data[4];
	aes_get_player_stats(id,data);
	if(data[0] < 25) {
		PrintChatColor(id, PRINT_COLOR_PLAYERTEAM,"!t[!gВип Тест!t] У вас не хватает опыта нужно !g25!t для тестирования.");
		return PLUGIN_HANDLED;
	}
	
	if(data[2] < 5) {
		PrintChatColor(id, PRINT_COLOR_PLAYERTEAM,"!t[!gВип Тест!t] У вас не хватает бонусов для тестирования.");
		return PLUGIN_HANDLED;
	}
	
	aes_add_player_bonus(id,-5);
	get_test(id)
	
	return PLUGIN_HANDLED;
}


public get_test(id) { 
	new steam[64];
	get_user_authid(id,steam,charsmax(steam));
	
	if(!gPlayerInDB[id] && !TrieKeyExists ( gArrExists, steam )) {
		AddPlayerFile(id);
		
		static ArrayPlayer[STRUSERDATA];
		new szSteamId[64];
		get_user_authid(id,szSteamId,charsmax(szSteamId));
		copy(ArrayPlayer[UD_STEAMID],sizeof(ArrayPlayer[UD_STEAMID]),szSteamId );
		ArrayPlayer[UD_TIME] = _:get_systime();
		
		ArrayPushArray(gArrUser, ArrayPlayer);
		TrieSetCell ( gTrieUser, ArrayPlayer[UD_STEAMID], gArrUserNum );
		gArrUserNum++
		
		new flags[24]
		get_pcvar_string(cvar_access_flag, flags, charsmax(flags));	
		set_user_flags(id,read_flags(flags))
		remove_user_flags(id,read_flags("z"))
		
		PrintChatColor(id, PRINT_COLOR_PLAYERTEAM,"!t[!gВип Тест!t] Тестирование випки.");
	} else {
		PrintChatColor(id, PRINT_COLOR_PLAYERTEAM,"!t[!gВип Тест!t] !tВы уже тестировали права.");
	}
}

public client_putinserver(id) {
	gPlayerInDB[id] = false;
	
	new szSteamId[64];
	get_user_authid(id,szSteamId,charsmax(szSteamId));
	if ( TrieKeyExists ( gTrieUser, szSteamId ) ) {
		static ArrayPlayer[STRUSERDATA], iArrayPos;
		TrieGetCell ( gTrieUser,szSteamId, iArrayPos )
		new iSize = ArraySize(gArrUser);
		if(iArrayPos < iSize) {
			ArrayGetArray ( gArrUser, iArrayPos, ArrayPlayer )
			
			new flags[24]
			get_pcvar_string(cvar_access_flag, flags, charsmax(flags));	
			set_user_flags(id,read_flags(flags))
			remove_user_flags(id,read_flags("z"))

		}
	}

	if ( TrieKeyExists ( gArrExists, szSteamId ) ) {
		gPlayerInDB[id] = false; 
	} else {
		ReadDataPlayer(id);
	}
}
public client_disconnect(id) {
	if(gPlayerInDB[id]) {
		new szSteamId[64];
		get_user_authid(id,szSteamId,charsmax(szSteamId));
		if ( TrieKeyExists ( gArrExists, szSteamId ) ) {
			TrieDeleteKey ( gArrExists, szSteamId )
		}
	}
}

public ReadUsers() { 
	new g_LoadDir[256];
	formatex(g_LoadDir, charsmax(g_LoadDir), "addons/amxmodx/data", g_LoadDir)
	if(!dir_exists(g_LoadDir)) {
		mkdir(g_LoadDir);
	}
	formatex(g_LoadDir, charsmax(g_LoadDir), "addons/amxmodx/data/users.ini", g_LoadDir)
	
	if(file_exists(g_LoadDir)) { 
		new szParse[256];
		
		static szName[64],szTime[32];
		static ArrayPlayer[STRUSERDATA];
		
		new iLine, iNum;
		for(iLine = 0; read_file(g_LoadDir, iLine, szParse, charsmax(szParse), iNum); iLine++) {
			if(szParse[0] != '/' && szParse[0] != ';' && iNum > 5 ) {
				if(iNum < sizeof(szParse)) {
					parse(szParse, 
						szName, sizeof(szName),
						szTime,  sizeof(szTime)
					);
					
					remove_quotes(szName);
					remove_quotes(szTime);

					
					copy(ArrayPlayer[UD_STEAMID],sizeof(ArrayPlayer[UD_STEAMID]),szName );
					ArrayPlayer[UD_TIME] = _:str_to_num(szTime);
					
					if(ArrayPlayer[UD_TIME] + (get_pcvar_num(cvar_time_test_vip)*60) < get_systime() && get_pcvar_num(cvar_time_test_vip) > 0 ) {
						
					} else {
						ArrayPushArray(gArrUser, ArrayPlayer);
						TrieSetCell ( gTrieUser, ArrayPlayer[UD_STEAMID], gArrUserNum );
						gArrUserNum++;
					}
				}
			}
		}
	}
}
public plugin_end() {
	if(file_exists("addons/amxmodx/data/users.ini"))
		delete_file("addons/amxmodx/data/users.ini");
	
	new iSize = ArraySize(gArrUser);
	for(new i=0;i<iSize;i++) {
		new ArrayPlayer[STRUSERDATA];
		ArrayGetArray(gArrUser, i, ArrayPlayer);
		
		static szText[256];
		format(szText,sizeof(szText),"^"%s^"^"%d^"",
			ArrayPlayer[UD_STEAMID],
			ArrayPlayer[UD_TIME]
		);
		write_file("addons/amxmodx/data/users.ini", szText, i);
	}
}

public ReadSave() { 
	
	new g_LoadDir[] = "addons/amxmodx/data";
	new mapName[33];
	get_mapname(mapName,charsmax(mapName));
	formatex(g_LoadData, charsmax(g_LoadData), "%s/save.ini", g_LoadDir)
	
	if(file_exists(g_LoadData)) { //Проверяем наличие файла.
		new szParse[256];
		
		static szSteam[32],szTime[32],szName[64],szIp[33];
		static ArrayPlayer[PLAYERDATA];
		
		new iLine, iNum;
		for(iLine = 0; read_file(g_LoadData, iLine, szParse, charsmax(szParse), iNum); iLine++) {
			if(szParse[0] != '/' && szParse[0] != ';' && iNum > 5 ) {
				if(iNum < sizeof(szParse)) {
					parse(szParse, //Распарсиваем.
						szSteam, sizeof(szSteam),
						szName, sizeof(szName),
						szIp, sizeof(szIp),
						szTime,  sizeof(szTime)
					);
					
					remove_quotes(szSteam);
					remove_quotes(szName);
					remove_quotes(szIp);
					remove_quotes(szTime);

					
					copy(ArrayPlayer[PL_STEAMID],sizeof(ArrayPlayer[PL_STEAMID]),szSteam );
					copy(ArrayPlayer[PL_NAME],sizeof(ArrayPlayer[PL_NAME]),szName );
					copy(ArrayPlayer[PL_IP],sizeof(ArrayPlayer[PL_IP]),szIp );
					ArrayPlayer[PL_TIME] = _:str_to_num(szTime);

					ArrayPushArray(gArrayPlayer, ArrayPlayer);
					TrieSetCell ( gTriePlPointer, ArrayPlayer[PL_STEAMID], gArrPlayerNum );
					TrieSetCell ( gTriePlPointer, ArrayPlayer[PL_NAME], gArrPlayerNum );
					TrieSetCell ( gTriePlPointer, ArrayPlayer[PL_IP], gArrPlayerNum );
					gArrPlayerNum++;
			
				}
			}
		}
		WriteAll();
	}
}
public WriteAll() { 
	
	new i,size = ArraySize(gArrayPlayer);
	for(i=gWriteLine;i<size;i++) {
		new ArrayPlayer[PLAYERDATA];
		ArrayGetArray(gArrayPlayer, i, ArrayPlayer);
		
		static szText[256];
		format(szText,sizeof(szText),"^"%s^" ^"%s^" ^"%s^" ^"%d^"",
			ArrayPlayer[PL_STEAMID],
			ArrayPlayer[PL_NAME],
			ArrayPlayer[PL_IP],
			ArrayPlayer[PL_TIME]
		);
		write_file(g_LoadData, szText, i);
	}
}

public ReadDataPlayer(id) { 
	
	new szString[3][32];
	get_user_authid(id,szString[0],charsmax(szString[]));
	get_user_name(id,szString[1],charsmax(szString[]));
	get_user_ip(id,szString[2],charsmax(szString[]),1);
	
	for(new i=0;i<sizeof(szString);i++) {
		if (TrieKeyExists ( gTriePlPointer, szString[i]))
		{
			static ArrayPlayer[PLAYERDATA], iArrayPos;
			TrieGetCell ( gTriePlPointer,szString[i], iArrayPos )
			ArrayGetArray ( gArrayPlayer, iArrayPos, ArrayPlayer )
			
			plData[id][PL_TIME] = ArrayPlayer[PL_TIME];
			plData[id][PL_ID] = iArrayPos;
			
			gPlayerInDB[id] = true;
			
			new steam[64];
			get_user_authid(id,steam,charsmax(steam));
			TrieSetCell ( gArrExists, steam, 1 );
			
		}
	}
}
public AddPlayerFile(id) { 
	
	static ArrayPlayer[PLAYERDATA];
	
	new szString[3][32];
	get_user_authid(id,szString[0],charsmax(szString[]));
	get_user_name(id,szString[1],charsmax(szString[]));
	get_user_ip(id,szString[2],charsmax(szString[]),1);
	
	for(new i=0;i<sizeof(szString);i++) {
	
		if(!TrieKeyExists ( gTriePlPointer, szString[i])) {
		
			copy(plData[id][PL_STEAMID],sizeof(plData[][PL_STEAMID]),szString[0] );
			copy(ArrayPlayer[PL_STEAMID],sizeof(ArrayPlayer[PL_STEAMID]),szString[0] );
			
			copy(plData[id][PL_NAME],sizeof(plData[][PL_NAME]),szString[1] );
			copy(ArrayPlayer[PL_NAME],sizeof(ArrayPlayer[PL_NAME]),szString[1] );
			
			copy(plData[id][PL_IP],sizeof(plData[][PL_IP]),szString[2] );
			copy(ArrayPlayer[PL_IP],sizeof(ArrayPlayer[PL_IP]),szString[2] );
			
			
			plData[id][PL_TIME] = get_systime();
			ArrayPlayer[PL_TIME] = get_systime();
			
			
			ArrayPushArray(gArrayPlayer, ArrayPlayer);
			TrieSetCell ( gTriePlPointer, szString[i], gArrPlayerNum );
			
			static szText[256];
			format(szText,sizeof(szText),"^"%s^" ^"%s^" ^"%s^" ^"%d^"",
				ArrayPlayer[PL_STEAMID],
				ArrayPlayer[PL_NAME],
				ArrayPlayer[PL_IP],
				ArrayPlayer[PL_TIME]
			);
			write_file(g_LoadData, szText, gArrPlayerNum);
			
			gArrPlayerNum++;
			gPlayerInDB[id] = true;
			TrieSetCell ( gArrExists, szString[0], 1 );
		}
	}
}





